//**********************************************************************
//**	Listbox widget for AMULET library
//**	Writen by Dusan Dedecek, 12th march 1997
//**	Contact: Dusan.Dedecek@st.mff.cuni.cz
//**********************************************************************

#include "listbox.h"

Am_Object Am_List_Box;
Am_Object Am_List_Group;
Am_Slot_Key Am_SELECTED_COLOR = Am_Register_Slot_Name("Am_SELECTED_COLOR");
Am_Slot_Key Am_MULTIPLE_SELECTION = Am_Register_Slot_Name("Am_MULTIPLE_SELECTION");

Am_Define_Method(Am_Object_Method, void, click_box_method, (Am_Object self))
{
	Am_Object obj = self.Get_Owner().Get_Owner().Get_Owner();
	if((bool) obj.Get_Owner().Get(Am_MULTIPLE_SELECTION))
	{
		if((bool) obj.Get(Am_SELECTED))
			obj.Set(Am_SELECTED, false);
	        else
			obj.Set(Am_SELECTED, true);
	} else {
		Am_Value_List list = obj.Get_Owner().Get(Am_GRAPHICAL_PARTS);
		Am_Object node;
		bool test = true;
		for (list.Start(); !list.Last() && test; list.Next())
		{
			node = list.Get();
			if((bool) node.Get(Am_SELECTED))
			{
				node.Set(Am_SELECTED, false);
				test = false;
			}
		}
		obj.Set(Am_SELECTED, true);
	}
}

Am_Define_Formula(int, width_from_owner)
{
	return (int) self.Get_Owner().Get(Am_WIDTH);
}

Am_Define_Formula(Am_Value, selected_owner_color)
{
	Am_Object list_box = self.Get_Owner().Get_Owner();
        if((bool) self.Get_Owner().Get(Am_SELECTED))
                return (Am_Value) list_box.Get(Am_SELECTED_COLOR);
        else
                return (Am_Value) list_box.Get(Am_FILL_STYLE);
}
 
Am_Object Am_List_Box_Initialize()
{
	Am_List_Box = Am_Scrolling_Group.Create("Am_List_Box")
		.Add(Am_MULTIPLE_SELECTION, true)
		.Add(Am_SELECTED_COLOR, Am_Amulet_Purple)
		.Set(Am_LAYOUT, Am_Vertical_Layout)
		.Set(Am_V_SPACING, 0)
		.Set(Am_INNER_WIDTH, Am_Width_Of_Parts)
		.Set(Am_INNER_HEIGHT, Am_Height_Of_Parts);

	Am_Object inter = Am_One_Shot_Interactor.Create("List_Rect_Inter")
		.Get_Object(Am_COMMAND)
                .Set(Am_DO_METHOD, click_box_method)
                .Get_Owner();

	Am_List_Group = Am_Group.Create("Am_List_Group")
		.Set(Am_WIDTH, width_from_owner)
		.Set(Am_HEIGHT, Am_Height_Of_Parts)
		.Add(Am_SELECTED, false)
		.Add_Part(Am_Rectangle.Create("List_Rectangle")
			.Add_Part(inter)
			.Set(Am_WIDTH, width_from_owner)
			.Set(Am_HEIGHT, 13)
			.Set(Am_LINE_STYLE, selected_owner_color)
			.Set(Am_FILL_STYLE, selected_owner_color)
		)
	;
	return Am_List_Box;
}
