//**********************************************************************
//**	Listbox widget  for AMULET library - test window
//**	Writen by Dusan Dedecek, 12th march 1997
//**	Contact: Dusan.Dedecek@st.mff.cuni.cz
//**********************************************************************

#include <amulet.h>
#include "listbox.h"

Am_Object Test;

Am_Object Test_Initialize () {

// Initialization of Listbox widget:
	Am_List_Box_Initialize();

// Example window:
  Test = Am_Window.Create("Test")
    .Set(Am_DESTROY_WINDOW_METHOD, Am_Default_Window_Destroy_Method)
    .Set(Am_FILL_STYLE, Am_White)
    .Set(Am_TITLE, "Test")
    .Set(Am_ICON_TITLE, "Test")
    .Set(Am_WIDTH , Am_Width_Of_Parts)
    .Set(Am_HEIGHT, Am_Height_Of_Parts)

// Listbox adding:

    .Add_Part(Am_List_Box.Create()

// Settings of inherited slots:

      .Set(Am_LEFT, 10)
      .Set(Am_TOP, 5)
      .Set(Am_WIDTH, 233)
      .Set(Am_HEIGHT, 175)
      .Set(Am_FILL_STYLE, Am_White)
      .Set(Am_H_SCROLL_BAR, 1)
      .Set(Am_V_SCROLL_BAR, 1)
      .Set(Am_H_SCROLL_BAR_ON_TOP, 0)
      .Set(Am_V_SCROLL_BAR_ON_LEFT, 0)

// Settings of Listbox slots:

	.Set(Am_SELECTED_COLOR, Am_Motif_Gray)
	.Set(Am_MULTIPLE_SELECTION, false)
	.Add_Part(Am_List_Group.Create()
		.Add_Part(Am_Text.Create().Set(Am_TEXT, "First")))
	.Add_Part(Am_List_Group.Create()
		.Add_Part(Am_Text.Create().Set(Am_TEXT, "Second")))
	.Add_Part(Am_List_Group.Create()
		.Add_Part(Am_Text.Create().Set(Am_TEXT, "A line")))
	.Add_Part(Am_List_Group.Create()
		.Add_Part(Am_Text.Create().Set(Am_TEXT, "B line")))

    )
  ;
  return Test;
}


int main(void) {

  Am_Initialize ();

  (void) Test_Initialize();

  Am_Object my_win = Am_Window.Create ("my_win")
    .Set (Am_LEFT, 20)
    .Set (Am_TOP, 50)
    .Set (Am_WIDTH, 400)
    .Set (Am_HEIGHT, 400);

  my_win.Add_Part(Test);

  Am_Screen.Add_Part (my_win);

  Am_Main_Event_Loop ();
  Am_Cleanup ();

  return 0;
}
